commit 7cbc7fb6506f913735f7c68d522bf26016607e1b
Author: jklowden <jklowden>
Date:   Thu Jul 24 22:04:49 2008 +0000

    test parameter binding with SQL_LONGVARCHAR

diff --git a/ChangeLog b/ChangeLog
index d4d4ad9..b538776 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Thu Jul 24 18:02:52 EDT 2008	JK Lowden <jklowden@freetds.org>
+	* samples/odbc_rpc.pl
+	* src/odbc/odbc.c src/odbc/prepare_query.c src/tds/net.c
+	- test parameter binding with SQL_LONGVARCHAR
+
 Wed Jul 23 16:05:41 EDT 2008	JK Lowden <jklowden@freetds.org>
 	* src/odbc/error.c src/odbc/odbc.c
 	- record error in log and remove some redundant logging of
@@ -469,4 +474,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2565 2008/07/23 20:07:17 jklowden Exp $
+$Id: ChangeLog,v 1.2566 2008/07/24 22:04:49 jklowden Exp $
diff --git a/samples/odbc_rpc.pl b/samples/odbc_rpc.pl
index cc93942..78b309e 100755
--- a/samples/odbc_rpc.pl
+++ b/samples/odbc_rpc.pl
@@ -1,5 +1,5 @@
 #!/usr/local/bin/perl
-# $Id: odbc_rpc.pl,v 1.7 2006/07/27 19:24:42 jklowden Exp $
+# $Id: odbc_rpc.pl,v 1.8 2008/07/24 22:04:49 jklowden Exp $
 #
 # Contributed by James K. Lowden and is hereby placed in 
 # the public domain.  No rights reserved.  
@@ -48,7 +48,16 @@ sub setup_error_handler($)
 
 $program = basename($0);
 
-Getopt::Std::getopts('U:P:D:d:h', \%opts);
+Getopt::Std::getopts('U:P:D:d:hlv', \%opts);
+
+if( $opts{l} ) {
+	foreach (@{ $DBI::EXPORT_TAGS{sql_types} }) {
+	      printf "%s=%d\n", $_, &{"DBI::$_"};
+	}
+	exit 0;
+}
+
+open VERBOSE, $opts{v}? '>&STDERR' : '>/dev/null' or die;
 
 my ($dsn, $user, $pass, $database);
 $dsn  = $opts{D}? $opts{D} : "dbi:ODBC:JDBC";
@@ -70,7 +79,7 @@ my $placeholders = '';
 if( @ARGV > 1 ) {
 	my @placeholders = ('?') x (@ARGV - 1); 
 	$placeholders = '(' . join( q(, ),  @placeholders ) . ')';
-	printf STDERR qq(%d arguments found for procedure "$ARGV[0]"\n), scalar(@placeholders);
+	printf VERBOSE qq(%d arguments found for procedure "$ARGV[0]"\n), scalar(@placeholders);
 }
 
 # Ready the odbc call
@@ -79,7 +88,7 @@ my $sth = $dbh->prepare( $sql );
 
 # Bind the return code as "inout".
 my $rc;
-print STDERR qq(Binding parameter #1, the return code\n);
+print VERBOSE qq(Binding parameter #1, the return code\n);
 $sth->bind_param_inout(1, \$rc, SQL_INTEGER);
 
 # Bind the input parameters (we don't do outputs in this example).
@@ -90,22 +99,31 @@ for( my $i=1; $i < @ARGV; $i++ ) {
     my $typename = 'SQL_VARCHAR';
     my $data = $ARGV[$i];
     if( $data =~ /^:([[:upper:]_]+):(.+)/ ) { # parse out the datatype, if any
-	$typename = $1;
-	$data = $2;
+    	$ARGV[$i] = $2;
+    	if( $1 eq 'FILE' ) {
+		$typename = 'SQL_LONGVARCHAR';
+		open INPUT, $2 or die qq(could not open "$2"\n);
+		my @data = <INPUT> or die qq(error reading "$2"\n);
+		$data = join '', @data;
+		close INPUT;
+	} else {
+		$typename = $1;
+		$data = $2;
+	}
         $type = eval($typename);
 	warn qq("$typename" will probably cause a "can't rebind parameter" message\n) 
 		if $type == SQL_DATETIME;
     }
-    printf STDERR qq(Binding parameter #%d (%s): "$data"\n), ($i+1), $typename;
+    printf VERBOSE qq(Binding parameter #%d (%s): "$data"\n), ($i+1), $typename;
     $sth->bind_param( 1 + $i, $data, $type );
 }
 
-print STDERR qq(\nExecuting: "$sth->{Statement}" with parameters '), 
+print STDOUT qq(\nExecuting: "$sth->{Statement}" with parameters '), 
 	     join(q(', '), @ARGV[1..$#ARGV]), qq('\n);
 
 # Execute the SQL and print the (possibly several) results
 $rc = $sth->execute;
-print STDERR qq(execute returned: '$rc'\n) if $rc;
+print STDOUT qq(execute returned: '$rc'\n) if $rc;
 
 $i = 1;
 while ( $sth->{Active} ) { 
@@ -121,3 +139,40 @@ $dbh->disconnect();
 
 exit 0;
 
+
+__END__
+
+=head1 NAME
+
+odbc_rpc - execute a stored procedure via DBD::ODBC
+
+=head1 SYNOPSIS
+
+odbc_rpc [-D dsn] [-U username] [-P password] I<procedure> [arg1[, argn]]
+odbc_rpc -l 
+
+=head1 DESCRIPTION
+
+Execute I<procedure> with zero or more arguments.  Arguments are assumed to be bound to 
+SQL_VARCHAR.  To use other bindings -- which might or might not work -- prefix the value with 
+:SQL_type: where type is a valid binding type.  For a list of recognized types, use "odbc_rpc -l". 
+
+To populate your parameter from a file instead of inline, use the form :FILE:filename.  odbc_rpc will
+open I<filename> and pass its contents as data.  
+
+
+=head1 EXAMPLE
+
+  odbc_rpc -D dbi:ODBC:mpquant -d testdb -U $U -P $P \
+  	   xmltest :FILE:samples/data.xml
+
+=head1 BUGS
+
+There is no way in DBD::ODBC to pass "long data".  The contents of the file must fit in memory. 
+
+
+=head1 Author
+
+Contributed to the FreeTDS project by James K. Lowden.  
+
+=cut
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 460eaeb..d86f3d9 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.486 2008/07/23 20:07:18 jklowden Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.487 2008/07/24 22:04:50 jklowden Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -5927,20 +5927,21 @@ SQLParamData(SQLHSTMT hstmt, SQLPOINTER FAR * prgbValue)
 {
 	INIT_HSTMT;
 
-	tdsdump_log(TDS_DBG_FUNC, "SQLParamData(%p, %p)\n", 
-			hstmt, prgbValue);
+	tdsdump_log(TDS_DBG_FUNC, "SQLParamData(%p, %p) [param_num %d, param_data_called = %d]\n", 
+					hstmt, prgbValue, stmt->param_num, stmt->param_data_called);
 
 	if (stmt->params && stmt->param_num <= stmt->param_count) {
 		SQLRETURN res;
 
 		if (stmt->param_num <= 0 || stmt->param_num > stmt->apd->header.sql_desc_count) {
-			/* TODO what error ?? */
+			tdsdump_log(TDS_DBG_FUNC, "SQLParamData: logic_error: parameter out of bounds: 0 <= %d < %d\n", 
+						   stmt->param_num, stmt->apd->header.sql_desc_count);
 			ODBC_RETURN(stmt, SQL_ERROR);
 		}
 
 		/*
 		 * TODO compute output value with this formula:
-		 * Bound Address + Binding Offset + ((Row Number – 1) x Element Size)
+		 * Bound Address + Binding Offset + ((Row Number - 1) x Element Size)
 		 * (see SQLParamData documentation)
 		 * This is needed for updates using SQLBulkOperation (not currently supported)
 		 */
@@ -5978,6 +5979,7 @@ SQLPutData(SQLHSTMT hstmt, SQLPOINTER rgbValue, SQLLEN cbValue)
 	}
 
 	/* TODO return correct error */
+	tdsdump_log(TDS_DBG_FUNC, "SQLPutData: returning SQL_ERROR\n");
 	ODBC_RETURN(stmt, SQL_ERROR);
 }
 
diff --git a/src/odbc/prepare_query.c b/src/odbc/prepare_query.c
index 48a071d..02200d9 100644
--- a/src/odbc/prepare_query.c
+++ b/src/odbc/prepare_query.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: prepare_query.c,v 1.67 2008/07/14 08:14:48 freddy77 Exp $");
+TDS_RCSID(var, "$Id: prepare_query.c,v 1.68 2008/07/24 22:04:50 jklowden Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -199,10 +199,15 @@ parse_prepared_query(struct _hstmt *stmt, int compute_row)
 	if (stmt->prepared_pos)
 		return prepared_rpc(stmt, compute_row);
 
+	tdsdump_log(TDS_DBG_FUNC, "parsing %d parameters\n", nparam);
+
 	for (; stmt->param_num <= stmt->param_count; ++nparam, ++stmt->param_num) {
-		/* find binded parameter */
+		/* find bound parameter */
 		if (stmt->param_num > stmt->apd->header.sql_desc_count || stmt->param_num > stmt->ipd->header.sql_desc_count) {
-			/* TODO set error */
+			tdsdump_log(TDS_DBG_FUNC, "parse_prepared_query: logic_error: parameter out of bounds: "
+						  "%d > %d || %d > %d\n", 
+						   stmt->param_num, stmt->apd->header.sql_desc_count, 
+						   stmt->param_num, stmt->ipd->header.sql_desc_count);
 			return SQL_ERROR;
 		}
 
@@ -246,6 +251,10 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 	TDSCOLUMN *curcol;
 	TDSBLOB *blob;
 	int sql_src_type;
+	
+	assert(stmt);
+	
+	tdsdump_log(TDS_DBG_FUNC, "continue_parse_prepared_query with parameter %d\n", stmt->param_num);
 
 	if (!stmt->params) {
 		tdsdump_log(TDS_DBG_FUNC, "error? continue_parse_prepared_query: no parameters provided");
diff --git a/src/tds/net.c b/src/tds/net.c
index 12475c2..14d38a6 100644
--- a/src/tds/net.c
+++ b/src/tds/net.c
@@ -103,7 +103,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: net.c,v 1.75 2008/07/15 15:25:07 freddy77 Exp $");
+TDS_RCSID(var, "$Id: net.c,v 1.76 2008/07/24 22:04:50 jklowden Exp $");
 
 #undef USE_POLL
 #if defined(HAVE_POLL_H) && defined(HAVE_POLL)
@@ -459,15 +459,14 @@ tds_select(TDSSOCKET * tds, unsigned tds_sel, int timeout_seconds)
 /**
  * Loops until we have received buflen characters
  * return -1 on failure
- * This function does not close the socket.  Maybe it should.  
  */
 static int
 tds_goodread(TDSSOCKET * tds, unsigned char *buf, int buflen, unsigned char unfinished)
 {
 	int rc, got = 0;
 
-	if (buf == NULL || buflen < 1 || tds == NULL)
-		return 0;
+	if (tds == NULL || buf == NULL || buflen < 1)
+		return -1;
 
 	for (;;) {
 		int len;

